# Makefile for GNU patch.
# Copyright 1993, 1997-1998, 1999 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.
# If not, write to the Free Software Foundation,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#### Start of system configuration section. ####

.IFDEF SHARED_BUILD
.IFDEF __AXP__
EXEEXT = .AXE
OBJ    = .ABJ
.ENDIF
.ENDIF

.IFDEF __AXP__
ARCH = _AXP
.ENDIF
.IFDEF __VAX__
ARCH = _VAX
.ENDIF

CC = cc

.ifdef DEBUG
CDF = /debug/noopt
LDF = /debug
.endif
.ifdef VERBOSE
.ifdef VERBOSE_SHOW
CVF = /list/show=($(VERBOSE_SHOW))
.else
CVF = /list
.endif
LFV = /map
.endif

        

CFLAGS = /stand=ansi89/prefix=(all,except=(getopt,optarg,optopt,optind,opterr)) $(cdf)$(cvf)
LFLAGS = $(LDF)$(LVF)

DEFS = VMS,HAVE_CONFIG_H

.ifdef EXEEXT
.else
EXEEXT = .exe
OBJ    = .obj
.endif


#### End of system configuration section. ####
.SUFFIXES
.SUFFIXES $(EXEEXT) .OLB $(OBJ) .c


LIBSRCS = getopt.c getopt1.c
SRCS = addext.c argmatch.c backupfile.c basename.c error.c inp.c maketime.c \
	mkdir.c partime.c patch.c pch.c quotearg.c quotesys.c \
	rmdir.c util.c version.c xmalloc.c vms.c
OBJS = addext$(OBJ) argmatch$(OBJ) backupfile$(OBJ) basename$(OBJ) error$(OBJ) inp$(OBJ) \
	maketime$(OBJ) partime$(OBJ) patch$(OBJ) pch$(OBJ) quotearg$(OBJ) quotesys$(OBJ) \
	util$(OBJ) version$(OBJ) xmalloc$(OBJ) vms$(OBJ)
LIBOBJS = getopt$(OBJ) getopt1$(OBJ) 
HDRS = argmatch.h backupfile.h basename.h common.h error.h getopt.h \
	inp.h maketime.h partime.h patchlevel.h pch.h quotearg.h quotesys.h \
	util.h version.h xalloc.h

LIB = PATCHLIB$(ARCH)
LIBFILE = $(LIB).OLB
!patch_name = `echo patch | sed '$(transform)'`

all :: $(LIB) patch$(EXEEXT)
        @ continue
info ::
check ::
installcheck ::

COMPILE = $(CC) /DEFINE=($(DEFS))  \
	/include=(sys$disk:[]) $(CFLAGS)

.c$(OBJ) :
	$(COMPILE) /OBJ=$(MMS$TARGET) $(MMS$SOURCE)
$(OBJ).OLB : 
   LIB $(MMS$TARGET) $(MMS$SOURCE)
patch$(EXEEXT) : PATCH$(obj) $(LIB)
	LINK $(LFLAGS)/EXE=$(MMS$TARGET) PATCH$(OBJ),$(lib)/LIB

install :: all installdirs
	$(INSTALL_PROGRAM) patch$(EXEEXT) $(bindir)/$(patch_name)$(EXEEXT)
	-$(INSTALL_DATA) patch.man $(man1dir)/$(patch_name)$(man1ext)

installdirs ::
	$(SHELL) mkinstalldirs $(bindir) $(man1dir)

install-strip ::
	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

uninstall ::
	rm -f $(bindir)/$(patch_name)$(EXEEXT)
	rm -f $(man1dir)/$(patch_name)$(man1ext)

!Makefile :  Makefile.in $(CONFIG_STATUS)
!	$(SHELL) $(CONFIG_STATUS)
!config.status: configure
!	$(SHELL) $(CONFIG_STATUS) --recheck

patchlevel.h : configure.in
	open/write fd patchlevel.h
	write fd "#define PATCH_VERSION ""$(VERSION)""
	close fd

mostlyclean ::
    if f$search("*.lis") .nes. "" then delete *.lis;*
    if f$search("*.map") .nes. "" then delete *.map;*
    if f$search("*$(OBJ)") .nes. "" then delete *$(OBJ);*

clean :: mostlyclean
    if f$search("*$(EXEEXT)") .nes. "" then delete patch$(EXEEXT);*

distclean :: clean
    if f$search("config.h") .nes. "" then delete config.h;*
!!!	rm -f Makefile config.cache config.log config.status config.h

PV = $(PACKAGE)-$(VERSION)

config.h : config.vms
    copy config.vms config.h


$(OBJS) : config.h
addext$(OBJ) : backupfile.h
argmatch$(OBJ) : argmatch.h error.h quotearg.h
backupfile$(OBJ) : argmatch.h backupfile.h
error$(OBJ) : error.h
getopt$(OBJ) : getopt.h
getopt1$(OBJ) : getopt.h
inp$(OBJ) : backupfile.h common.h inp.h pch.h quotearg.h util.h xalloc.h
maketime$(OBJ) : maketime.h partime.h
partime$(OBJ) : partime.h
patch$(OBJ) : argmatch.h backupfile.h common.h getopt.h inp.h \
	pch.h quotearg.h util.h version.h xalloc.h
pch$(OBJ) : backupfile.h basename.h common.h inp.h pch.h quotearg.h util.h
quotearg$(OBJ) : quotearg.h xalloc.h
quotesys$(OBJ) : quotesys.h
util$(OBJ) : backupfile.h basename.h common.h maketime.h \
	partime.h quotearg.h quotesys.h util.h version.h xalloc.h
version$(OBJ) : common.h patchlevel.h util.h version.h
xmalloc$(OBJ) : xalloc.h

$(LIBFILE) : 
    if f$search("$(MMS$TARGET)") .eqs. "" then lib/create $(MMS$TARGET)
                                       
$(LIB)(ADDEXT)     : ADDEXT$(OBJ)
                     library $(mms$target)  $(mms$source)
$(LIB)(argmatch)   : argmatch$(OBJ)      
                     library $(mms$target)  $(mms$source)
$(LIB)(backupfile) : backupfile$(OBJ)    
                     library $(mms$target)  $(mms$source)
$(LIB)(basename)   : basename$(OBJ)      
                     library $(mms$target)  $(mms$source)
$(LIB)(error)      : error$(OBJ)         
                     library $(mms$target)  $(mms$source)
$(LIB)(inp)        : inp$(OBJ)           
                     library $(mms$target)  $(mms$source)
$(LIB)(maketime)   : maketime$(OBJ)      
                     library $(mms$target)  $(mms$source)
$(LIB)(partime)    : partime$(OBJ)       
                     library $(mms$target)  $(mms$source)
$(LIB)(pch)        : pch$(OBJ)           
                     library $(mms$target)  $(mms$source)
$(LIB)(quotearg)   : quotearg$(OBJ)      
                     library $(mms$target)  $(mms$source)
$(LIB)(quotesys)   : quotesys$(OBJ)      
                     library $(mms$target)  $(mms$source)
$(LIB)(util)       : util$(OBJ)          
                     library $(mms$target)  $(mms$source)
$(LIB)(version)    : version$(OBJ)       
                     library $(mms$target)  $(mms$source)
$(LIB)(xmalloc)    : xmalloc$(OBJ)       
                     library $(mms$target)  $(mms$source)
$(LIB)(vms)        : vms$(OBJ)       
                     library $(mms$target)  $(mms$source)

$(LIB)(getopt)     : getopt$(OBJ)
                     library $(mms$target)  $(mms$source)
$(LIB)(getopt1)    : getopt1$(OBJ)
                     library $(mms$target)  $(mms$source)

$(LIB) : $(LIBFILE) $(LIB)(ADDEXT) $(LIB)(argmatch) $(LIB)(backupfile) $(LIB)(basename) \
         $(LIB)(error) $(LIB)(inp) $(LIB)(maketime) $(LIB)(partime)   \
         $(LIB)(pch) $(LIB)(quotearg) $(LIB)(quotesys) \
         $(LIB)(util) $(LIB)(version) $(LIB)(xmalloc) $(LIB)(vms)\
         $(LIB)(getopt) $(LIB)(getopt1)
        @ CONTINUE
